<?php

namespace RhodesIsland\OAuthCenter\Api\Controller;

use Flarum\Api\Controller\AbstractCreateController;
use Flarum\Http\RequestUtil;
use Illuminate\Support\Arr;
use Psr\Http\Message\ServerRequestInterface;
use Tobscure\JsonApi\Document;
use RhodesIsland\OAuthCenter\Models\Client;
use RhodesIsland\OAuthCenter\Api\Serializer\ClientSerializer;

class CreateClientController extends AbstractCreateController
{
    public $serializer = ClientSerializer::class;
    protected function data(ServerRequestInterface $request, Document $document)
    {
        $actor = RequestUtil::getActor($request);
        $actor->assertAdmin();

        $attributes = Arr::get($request->getParsedBody(), 'data.attributes');

        $validAttrs = [
            'user_id' => $actor->id
        ];

        collect(['client_id', 'client_secret', 'redirect_uri', 'grant_types', 'scope', 'client_name', 'client_desc', 'client_icon', 'client_home'])
            ->each(function (string $attribute) use (&$validAttrs, $attributes) {
                if (($val = Arr::get($attributes, $attribute)) !== null) {
                    $validAttrs[$attribute] = $val;
                }
            });

        return Client::create($validAttrs);
    }
}
